import { BaseContract } from "../implementations/BaseContract.js";
import { ContractOverrides, IMinimalForwarderContract, IMinimalForwarderRequest, WrappedTransactionResponse } from "../interfaces/index.js";
import { EVMAccountAddress, EVMContractAddress, MinimalForwarderContractError, BigNumberString, Signature } from "@snickerdoodlelabs/objects";
import { ethers } from "ethers";
import { ResultAsync } from "neverthrow";
export declare class MinimalForwarderContract extends BaseContract<MinimalForwarderContractError> implements IMinimalForwarderContract {
    protected providerOrSigner: ethers.providers.Provider | ethers.providers.JsonRpcSigner | ethers.Wallet;
    protected contractAddress: EVMContractAddress;
    constructor(providerOrSigner: ethers.providers.Provider | ethers.providers.JsonRpcSigner | ethers.Wallet, contractAddress: EVMContractAddress);
    getContractAddress(): EVMContractAddress;
    getNonce(from: EVMAccountAddress): ResultAsync<BigNumberString, MinimalForwarderContractError>;
    verify(request: IMinimalForwarderRequest, signature: Signature): ResultAsync<boolean, MinimalForwarderContractError>;
    execute(request: IMinimalForwarderRequest, signature: Signature, overrides?: ContractOverrides): ResultAsync<WrappedTransactionResponse, MinimalForwarderContractError>;
    protected generateError(msg: string, reason: string | undefined, e: unknown): MinimalForwarderContractError;
}
//# sourceMappingURL=MinimalForwarderContract.d.ts.map