import { BaseContract } from "../implementations/BaseContract.js";
import { ContractOverrides, IRewardsContractFactory } from "../interfaces/index.js";
import { WrappedTransactionResponse } from "../interfaces/objects/index.js";
import { BaseURI, RewardsFactoryError, ECreatedRewardType } from "@snickerdoodlelabs/objects";
import { ethers } from "ethers";
import { ResultAsync } from "neverthrow";
export declare class RewardsContractFactory extends BaseContract<RewardsFactoryError> implements IRewardsContractFactory {
    protected providerOrSigner: ethers.providers.Provider | ethers.providers.JsonRpcSigner | ethers.Wallet;
    protected rewardType: ECreatedRewardType;
    protected contractFactory: ethers.ContractFactory;
    protected rewardTypeToDeploy: ECreatedRewardType;
    constructor(providerOrSigner: ethers.providers.Provider | ethers.providers.JsonRpcSigner | ethers.Wallet, rewardType: ECreatedRewardType);
    deployERC721Reward(name: string, symbol: string, baseURI: BaseURI, overrides: ContractOverrides): ResultAsync<WrappedTransactionResponse, RewardsFactoryError>;
    estimateGasToDeployERC721Contract(name: string, symbol: string, baseURI: BaseURI): ResultAsync<ethers.BigNumber, RewardsFactoryError>;
    protected generateError(msg: string, reason: string | undefined, e: unknown): RewardsFactoryError;
    protected writeToContractFactory(functionName: string, functionParams: any[], overrides?: ContractOverrides, isDeployingContract?: boolean): ResultAsync<WrappedTransactionResponse, RewardsFactoryError>;
}
//# sourceMappingURL=RewardsContractFactory.d.ts.map