import { BaseContract } from "../implementations/BaseContract.js";
import { WrappedTransactionResponse } from "../interfaces/index.js";
import { ISiftContract } from "../interfaces/ISiftContract.js";
import { ContractOverrides } from "../interfaces/objects/ContractOverrides.js";
import { EVMContractAddress, TokenUri, SiftContractError, BaseURI, DomainName } from "@snickerdoodlelabs/objects";
import { ethers } from "ethers";
import { ResultAsync } from "neverthrow";
export declare class SiftContract extends BaseContract<SiftContractError> implements ISiftContract {
    protected providerOrSigner: ethers.providers.Provider | ethers.providers.JsonRpcSigner | ethers.Wallet;
    protected contractAddress: EVMContractAddress;
    constructor(providerOrSigner: ethers.providers.Provider | ethers.providers.JsonRpcSigner | ethers.Wallet, contractAddress: EVMContractAddress);
    getContractAddress(): EVMContractAddress;
    checkURL(domain: DomainName): ResultAsync<TokenUri, SiftContractError>;
    verifyURL(domain: DomainName, overrides?: ContractOverrides): ResultAsync<WrappedTransactionResponse, SiftContractError>;
    maliciousURL(domain: DomainName, overrides?: ContractOverrides): ResultAsync<WrappedTransactionResponse, SiftContractError>;
    setBaseURI(baseUri: BaseURI, overrides?: ContractOverrides): ResultAsync<WrappedTransactionResponse, SiftContractError>;
    protected generateError(msg: string, reason: string | undefined, e: unknown): SiftContractError;
}
//# sourceMappingURL=SiftContract.d.ts.map