import { IBaseContract } from "../interfaces/IBaseContract.js";
import { ContractOverrides, IMinimalForwarderRequest, WrappedTransactionResponse } from "../interfaces/objects";
import { EVMAccountAddress, MinimalForwarderContractError, BigNumberString, Signature } from "@snickerdoodlelabs/objects";
import { ResultAsync } from "neverthrow";
export interface IMinimalForwarderContract extends IBaseContract {
    getNonce(from: EVMAccountAddress): ResultAsync<BigNumberString, MinimalForwarderContractError>;
    verify(request: IMinimalForwarderRequest, signature: Signature): ResultAsync<boolean, MinimalForwarderContractError>;
    execute(request: IMinimalForwarderRequest, signature: Signature, overrides?: ContractOverrides): ResultAsync<WrappedTransactionResponse, MinimalForwarderContractError>;
}
export declare const IMinimalForwarderContractType: unique symbol;
//# sourceMappingURL=IMinimalForwarderContract.d.ts.map